require 'dalli'
require 'hikki'

module Hikki
  module Adapters
    class MemcacheAdapter < Hikki::Adapters::Adapter
      attr_reader :connection, :uuid_generator

      def initialize(connection=Dalli::Client.new('localhost:11211', { namespace: 'hikki', compress: true }), uuid_generator=SecureRandom)
        super()
        @connection = connection
        @uuid_generator = uuid_generator
      end

      def collection_for(collection)
        collections.fetch(collection, MemcacheCollection.new(collection, connection, uuid_generator))
      end

    end
  end
end